import PrintOptions from './PrintOptions';
import FileName from './FileName';
import IdentifierName from './IdentifierName';
export interface FileContext {
    getImport: (fileExport: FileExport) => string;
}
export interface FileExport {
    file: FileName;
    isDefaultExport: () => boolean;
    exportName: string;
}
export default class PrintContext<TypeID> {
    private readonly _files;
    readonly options: PrintOptions<TypeID>;
    constructor(options: PrintOptions<TypeID>);
    private _pushDeclaration;
    pushTypeDeclaration(id: TypeID, declaration: (identifier: IdentifierName, imp: FileContext) => string[]): FileExport;
    pushValueDeclaration(id: TypeID, declaration: (identifier: IdentifierName, imp: FileContext) => string[]): FileExport;
    getFiles(): {
        filename: FileName;
        content: string;
    }[];
}
